\begin{tikzpicture}
  \tikzset{node distance=0.5cm}

  \tikzstyle{startstop} = [
    rectangle, rounded corners, minimum width=3cm, minimum height=1cm,
    text centered, draw=black, fill=red!50, ultra thick
  ]

  \tikzstyle{input} = [
    trapezium, trapezium stretches=true, trapezium left angle=70,
    trapezium right angle=110, minimum width=3cm, minimum height=1cm,
    text centered, draw=black, fill=cyan!50, ultra thick
  ]

  \tikzstyle{process} = [
    rectangle, minimum width=3cm, minimum height=1cm, text centered, 
    text width=3cm, draw=black, fill=yellow!50, ultra thick
  ]

  \tikzstyle{decision} = [
    diamond, minimum width=3cm, minimum height=1cm, text centered,
    draw=black, fill=green!50, ultra thick
  ]

  \tikzstyle{arrow} = [ultra thick,->,>=stealth]

  \node (start) [startstop] {Start};

  \node (segments_input) [input, below=of start, anchor=north] {Segments input};

  \node (request_permission)
    [process, below=of segments_input, anchor=north] {Request permission};

  \node (permission_granted)
    [decision, below=of request_permission, anchor=north] {Permission granted?};

  \node (wait_for_permission)
    [process, left=of permission_granted, anchor=east] {Wait some time};

  \node (navigate_segment)
    [process, below=of permission_granted, anchor=north] {Navigate segment};

  \node (end_of_segment)
    [decision, below=of navigate_segment, anchor=north] {End of segment?};

  \node (is_last_segment)
    [decision, below=of end_of_segment, anchor=north] {Is last segment?};

  \node (release_segment)
    [process, below=of is_last_segment, anchor=north] {Release segment};

  \node (stop)
    [startstop, below=of release_segment, anchor=north] {Stop};

  \draw [arrow] (start) -- (segments_input);
  \draw [arrow] (segments_input) -- (request_permission);
  \draw [arrow] (request_permission) -- (permission_granted);

  \draw [arrow] (permission_granted) -- node[anchor=south]
    {no} (wait_for_permission);
  \draw [arrow] (permission_granted) -- node[anchor=east]
    {yes} (navigate_segment);

  \draw [arrow] (wait_for_permission) |- (request_permission);

  \draw [arrow] (navigate_segment) -- (end_of_segment);

  \draw [arrow] (end_of_segment) -- node[anchor=east]
    {yes} (is_last_segment);
  \draw [arrow] (end_of_segment) -- ++(3.0,0.0) |- (navigate_segment.east)
    node[anchor=south west] {no};

  \draw [arrow] (is_last_segment) -- node[anchor=east]
    {yes} (release_segment);
  \draw [arrow] (is_last_segment) -- ++(4.0,0.0) |- (request_permission.east)
    node[anchor=south west] {no};

  \draw [arrow] (release_segment) -- (stop);
\end{tikzpicture}
